/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * Localize.hpp
 *
 *  Created on: 2011/01/14
 *      Author: HARK Development Team
 */

#ifndef LOCALIZE_HPP_
#define LOCALIZE_HPP_

#include <vector>
#include <boost/shared_ptr.hpp>
#include <AngleAndProbability.hpp>
#include <HarmonicSound.hpp>
#include <DirectionJudge.hpp>
#include <InterauralDifference.hpp>
#include <MethodFlag.hpp>

namespace NSHarkBinaural
{

class Localize
{
public:
    /*
    typedef std::vector<AngleAndProbability> AngleProbabilityVector;
    typedef boost::shared_ptr<AngleProbabilityVector> AngleProbabilityVectorPtr;
    typedef std::vector<AngleProbabilityVectorPtr> AngleProbabilityVectorVector;
    typedef boost::shared_ptr<AngleProbabilityVectorVector> AngleProbabilityVectorVectorPtr;
    */

    typedef DirectionJudge::DirectionProbabilityVector DirectionProbabilityVector;
    typedef boost::shared_ptr<DirectionProbabilityVector> DirectionProbabilityVectorPtr;
    typedef std::vector<DirectionProbabilityVectorPtr> DirectionProbabilityVectorVector;
    typedef boost::shared_ptr<DirectionProbabilityVectorVector> DirectionProbabilityVectorVectorPtr;

    typedef boost::shared_ptr<HarmonicSound> HarmonicSoundPtr;
    typedef std::vector<HarmonicSoundPtr> HarmonicSoundVector;
    typedef boost::shared_ptr<HarmonicSoundVector> HarmonicSoundVectorPtr;

    /**
     * 与えられた調波構造の方向と、その方向である確信度を取得する.
     */
    static DirectionProbabilityVectorPtr
    GetDirection(HarmonicSoundPtr sound, const BandInformation& bi,
                 DirectionJudge& judge, IPD::ptr_t ipd, IID::ptr_t iid, MethodFlag::Kind mflag, bool sortByProbability);

    static DirectionProbabilityVectorVectorPtr
    GetDirections(HarmonicSoundVectorPtr sounds, const BandInformation& bi,
                  DirectionJudge& judge, IPD::ptr_t ipd, IID::ptr_t iid, MethodFlag::Kind mflag, bool sortByProbability = true);
};

}

#endif /* LOCALIZE_HPP_ */
